--[[local function getTime()
    return os.time()
end
function table.insert(t,v)
    t[#t+1] = v
end
local test = {}
local x,y = 4, 5
local p = {x,y}
local s = getTime()

table.insert(test,p)
local ss = os.difftime(s)

error("That took "..ss.." to complete")]]
--[[_g = {}
for u,i in pairs(_G) do _g[u] = i end
nextC=0
function changeC()
    self.player.color=colorList[nextC]
    nextC=nextC+1
    log(self.player.color)
end


colorList = { "tan", "steelblue", "ghostwhite", "sandybrown", "mistyrose", "antiquewhite", "bisque", "firebrick", "gainsboro", "cornflowerblue", "oldlace", "orange", "lightpink", "gold", "darkolivegreen", "aliceblue", "blueviolet", "gray", "dimgrey", "aqua", "powderblue", "dodgerblue", "olive", "midnightblue", "snow", "navy", "yellowgreen", "moccasin", "crimson", "deeppink", "lightblue", "darkorange", "darkturquoise", "darkblue", "grey", "indigo", "lightgray", "honeydew", "lightsalmon", "indianred", "thistle", "darkred", "coral", "skyblue", "darkseagreen", "blue", "lavender", "lightgreen", "red", "goldenrod", "yellow", "slateblue", "mediumaquamarine", "rosybrown", "cyan", "darkgoldenrod", "darkgray", "violet", "white", "wheat", "maroon", "forestgreen", "limegreen", "mediumblue", "mediumspringgreen", "blanchedalmond", "peru", "mediumturquoise", "slategray", "lightcoral", "magenta", "turquoise", "darkslateblue", "palevioletred", "sienna", "lightslategray", "mediumpurple", "silver", "ivory", "royalblue", "lightyellow", "palegoldenrod", "chartreuse", "lemonchiffon", "cornsilk", "saddlebrown", "orangered", "lavenderblush", "tomato", "papayawhip", "chocolate", "khaki", "pink", "greenyellow", "navajowhite", "teal", "darkorchid", "darkgrey", "darksalmon", "deepskyblue", "darkcyan", "mediumslateblue", "darkslategray", "hotpink", "darkviolet", "brown", "plum", "aquamarine", "lightgoldenrodyellow", "slategrey", "lightsteelblue", "mintcream", "lightcyan", "lime", "mediumvioletred", "seagreen", "mediumseagreen", "salmon", "lightslategrey", "dimgray", "beige", "darkgreen", "lightgrey", "green", "palegreen", "seashell", "paleturquoise", "darkmagenta", "black", "olivedrab", "darkkhaki", "purple", "burlywood", "mediumorchid", "linen", "cadetblue", "peachpuff", "darkslategrey", "lawngreen", "lightskyblue", "springgreen", "floralwhite", "azure", "whitesmoke", "orchid", "fuchsia" }
]]
love._run = love.run


love.oldmyrun = function()
    local n = love._run()
    local nn = function()
    if ggy then log("!!!!!%") ddef=3
        ProFi:start()
    end n() --assert(not ggy)
    if ggy and ddef then
        ProFi:stop()
        ProFi:writeReport("urun.txt")
        ggy = nil log("!??*")
    end end return nn
    
end
floor = math.floor

function love.run()
	if love.load then love.load(love.arg.parseGameArguments(arg), arg) end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end

	local dt = 0

	-- Main loop time.
	return function()
		-- Process events.
		if love.event then
			love.event.pump()
			for name, a,b,c,d,e,f in love.event.poll() do
				if name == "quit" then
					if not love.quit or not love.quit() then
						return a or 0
					end
				end
				love.handlers[name](a,b,c,d,e,f)
			end
		end

		-- Update dt, as we'll be passing it to update
		if love.timer then dt = love.timer.step() end

		-- Call update and draw
		if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled

		if love.graphics and love.graphics.isActive() then
			love.graphics.origin()
			love.graphics.clear(love.graphics.getBackgroundColor())

			if love.draw then love.draw(dt) end

			love.graphics.present()
		end

		--commenting it out makes game faster?
		--if love.timer then love.timer.sleep(0.001) end
	end

end

    ty=function() for r=1,14 do game.map:spawnCrate() end end
--pcall(command) = bool completed, error msg or return
function love.load()
    game = {}
    _dat = {}
    getSource = function(s)
        _dat[s] = _dat[s] or love.graphics.newImage("assets/"..s)
        return _dat[s]
    end
    function game:getSource(s)
        return getSource(s)
    end
    MAX_PLAYERS = 9
    MAP_SEED = 15--??
    OBJECT_POOLING = false
    doDebug = true--false
    returnTick = 1--don't return prematurely in update
    tlen = function(t)
        local l = #t
        for x,i in pairs(t) do
            l = l+1
        end
        return l
    end
    
    RECORDS = {
        updateCount = 0
    }
    getUpdateCount = function()
        return RECORDS.updateCount
    end
    
    loadLuaCode = _G.load
    
    --class
    class = require 'tools/class'


    --home brewed helper functions
    require 'tools/tools'



    font13 = love.graphics.newFont(H(30))
    font8 = love.graphics.newFont(H(20))
    
    --font13 = love.graphics.newFont(love.window.toPixels(H(20)))
    --font8 = love.graphics.newFont(love.window.toPixels(H(15)))
    
    --home brewed helper classes
    --Animation = require 'tools/animation'
    --Scheduler = require 'tools/scheduler'
    --Joystick = require 'tools/joystick'
    local bars = require 'tools/bars'
    LifeBar, ProgressionBar = bars[1],bars[2] --require 'tools/bars'

    --stuffses
    require 'tools/gooi'
    --require "tools/goap"



    --helper functions/variables
    color = require 'tools/color'
    --mlib = require 'tools/mlib'
    --sti = require "tools/sti"
    rot = require "tools/src.rot"
    lume = require 'tools/lume'
    colors = color
    bump = require 'tools/bump'
    inspect = require 'tools/inspect'
    --json = require 'tools/json'
    animx = require 'tools/animx'
    
    randomchoice = lume.randomchoice
    --styles
    scifiStyle = {
        bgColor = colors.blue,
        borderColor = colors.black,
        showBorder = true
    }
    dustStyle = {
        bgColor ={176/255,122/255,14/255},-- colors.darkbrown,
        borderColor = colors.black,
        showBorder = true
    }

    gooi.desktopMode()
    gooi.setStyle(dustStyle)


    --helper classes and stuff
    ProFi = require "tools/ProFi"
    Camera = require 'tools/camera'
    listbox = require 'tools/listbox'
    Paddy = require 'tools/paddy'
    JumperGrid = require "tools/jumper.grid"
    PathFinder = require "tools/jumper.pathfinder"
    Gamestate = require "tools/hump/gamestate"
    --Signal = require "tools/hump/signal"
    Timer = require "tools/hump/timer"
    saveTable = require "tools/saveTable"
    splashy = require "tools/splashy"
    --Graph = require "tools/graph"
    Andralog = require "tools/andralog"
    --LoveAnimation = require "tools/loveAnimation"
    multisource = require "tools/multisource"
    bitser = require "tools/bitser"
    sock = require "tools/sock"
    Chrono = require "tools/chrono"
    --windfield = require "tools/windfield"
    --wf = windfield
    



    --base classes
    Entity = require "bases/entity"
    Tile = require "bases/tile"
    --SpriteSkeleton = require "bases/spriteSkeleton"
    
    --entities
    Bullet = require "entities/bullet"
    Turret = require "entities/turret"
    Mini = require "entities/mini"
    Crate = require "entities/crate"
    
    Puff = require "entities/puff"
    Debris = require "entities/debris"
    Explosion = require "entities/explosion"
    

    bullets = require "data/bullets"


    ---Map
    Map = require "map"


    DT = 0
    DTmax = .5

    ---Shortcuts for often used functions, variables, etc...---
    Gs = Gamestate
    GS = Gamestate
    GSwitch = Gamestate.switch
    Gss = Gamestate.switch
    GSS = Gamestate.switch
    
    
    ---For switching back to the old state (can also use actual index in class: .oldState)---
    OLD_STATE = nil


    Gamestate.registerEvents()
    local map = Map:new()
    map:build()
    game.map = map
    GSS(map)
    
end
